#include <Types.h>
#include <Memory.h>
#include <Quickdraw.h>
#include <Fonts.h>
#include <Events.h>
#include <Menus.h>
#include <Windows.h>
#include <Devices.h>



#include "CEgFileSpec.h"
#include "G-Force.h"
#include "EgOSUtils.h"
#include "SoundInputPort.h"








// Prototypes
OSErr InstallRequiredAppleEvents (void);
pascal OSErr HandleOApp (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefcon);
pascal OSErr HandleQuit (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefcon);
//pascal OSErr InstallRequiredAppleEvents ();

void Initialize(void);
void			 MenuBarInit();

// Globals
int				gQuitting;
GForce*			gGF;
WindowPtr		gGF_Wind;





static OSErr DispatchMenuChoice ( long menuChoice) {
	OSErr						err					= noErr;
	short						menu;
	short						item, accNumber;
	MenuHandle					appleMenu;
	Str255						accName;
	
	if (menuChoice != 0) {
		menu = ((unsigned long) menuChoice) >> 16;
		item = menuChoice & 0xFFFF;
		switch (menu) {
			case 555:	// Apple Menu
				appleMenu = GetMenuHandle (555);
				GetMenuItemText (appleMenu, item, accName);
				accNumber = OpenDeskAcc (accName);
				break;
			case 556:	// File Menu
				switch (item) {
					case 1:	// Quit
						gQuitting = true;
				}
				break;
			case 558: 	// Window Menu
				switch (item) {
					case 1:
						if ( ! gGF -> IsFullscreen() ) {
							if ( ( (WindowPeek) gGF_Wind ) -> visible )
								::HideWindow( gGF_Wind );
							else
								::ShowWindow( gGF_Wind );
						}
						break;
							
					case 3:
						gGF -> SetFullscreen( ! gGF -> IsFullscreen() );
				}
				break;
		}
	}

	HiliteMenu (0);

	return err;
}




//MW specified argument and return type.
int main(void)
{
	bool 						inForeground = true, isVisible;
	//unsigned char				wasProcessed;
	OSErr						err;
	EventRecord					event;
	WindowPtr wind;
	SoundInput  				soundPort;
	long i;
	float*  temp = NULL;
	
	long dimmedNumSteps = 0, steps;
	UtilStr samplesBuf;
	Initialize();
	

	gGF = new GForce();
	
	Rect r = { 0, 0, 0, 0 };
	if ( gGF -> BorderlessWindow() && 0 )
		gGF_Wind = ::NewCWindow( NULL, &r, "\pG-Force", false, plainDBox,	(WindowPtr)-1, true, NULL );
	else
		gGF_Wind = ::NewCWindow( NULL, &r, "\pG-Force", false, 1985,		(WindowPtr)-1, true, NULL );

	gGF -> SetWinPort( gGF_Wind );

	soundPort.SetSampleSkip( 0 );
	err = soundPort.StartRecording();
	gQuitting = err != noErr;


	
	
	while ( ! gQuitting ) {
		isVisible = ( (WindowPeek) gGF_Wind ) -> visible || gGF -> IsFullscreen();
		inForeground = inForeground || gGF -> IsFullscreen();
	
		::WaitNextEvent (everyEvent, &event, ( inForeground && isVisible ) ? 0 : 20, NULL );
		/*
		if ( gGF -> IsFullscreen() ) {
			::DSpProcessEvent( &event, &wasProcessed );
			if ( wasProcessed )
				return 0;
		}*/
			
		switch ( event.what ) {
		
			case updateEvt:	
				gGF -> HandleEvt( gGF_Wind, event );
				break;
			
			case kHighLevelEvent:
				err = AEProcessAppleEvent (&event);
				break;
				
			case keyDown:
				if (event.modifiers & cmdKey)
					err = DispatchMenuChoice ( MenuKey( (event.message & charCodeMask)) );
				else
					gGF -> HandleKey( event.message  & charCodeMask );
				break;

			case osEvt:
				switch ((event.message >> 24) & 0x00FF) {		// get high byte of message
					case suspendResumeMessage:
					
						// set the foreground/background state
						inForeground = ((event.message & resumeFlag) != 0);
						break;
					
					case mouseMovedMessage:
						break;
				}
				break;
				
				
			case mouseDown:	
				Point inPt = event.where;
				i = ::FindWindow ( inPt, &wind );
				switch ( i ) {
					Rect lim;
					case inMenuBar:
						::CheckItem( GetMenuHandle( 558 ), 1, ( (WindowPeek) gGF_Wind ) -> visible );
						DispatchMenuChoice( MenuSelect (event.where));
						break;
						
					case inDrag:
						lim.top = lim.left = 0;
						lim.bottom = lim.right = 9000;
						::DragWindow( gGF_Wind, event.where, &lim );
						break;
						
				/*	case inZoomIn:
					case inZoomOut:
						if ( ::TrackBox( gGF_Wind, event.where, i ) )
							gGF -> SetFullscreen( true );
						break;*/
						
					case inGoAway:
						if ( ::TrackGoAway( gGF_Wind, event.where ) )
							::HideWindow( gGF_Wind );
						break;
						
					case inContent:
						gGF -> HandleEvt( gGF_Wind, event );
						break;
						
				}
			}

		// If the WC window is visible then process a sound sample
		if ( isVisible ) {
		
			// Resize our temp buf if it's too small...
			steps = gGF -> DefaultNum_S_Steps();
			if ( steps > dimmedNumSteps ) {
				temp = (float*) samplesBuf.Dim( sizeof( float ) * steps + 16 );
				dimmedNumSteps = steps;
			}
			
			// Get some samples
			soundPort.GetSamples( temp, dimmedNumSteps );

			// Record the freq sample and draw!
			gGF -> RecordSample( EgOSUtils::CurTimeMS(), temp, .000019, dimmedNumSteps );
		}
	}


	

	delete gGF;
	

	::DisposeWindow( gGF_Wind );
	
	EgOSUtils::Shutdown();

	return 0;	
}






// 
//	Initialize everything for the program, make sure we can run
//

//MW specified argument and return type.
void Initialize(void)
{
	
	/* Initialize all the needed managers. */
	MaxApplZone ();
	InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);
	InitCursor();


	Handle					menuBar;
	MenuHandle				menu;
	OSErr					err				= noErr;

	err = InstallRequiredAppleEvents ();

	menuBar = GetNewMBar (555);
	if (menuBar != nil) {
		SetMenuBar (menuBar);
		menu = GetMenuHandle (555);
		if (menu != nil) {
			AppendResMenu (menu, 'DRVR');
			DrawMenuBar ();
		} else {
			err = memFullErr;
		}
	}

	EgOSUtils::Initialize();
	
	ScreenDevice::sMinDepth = 8;		

}




OSErr InstallRequiredAppleEvents () {
	OSErr		err;

	err = AEInstallEventHandler (kCoreEventClass, kAEOpenApplication, NewAEEventHandlerProc (HandleOApp), 0, false);


	err = AEInstallEventHandler (kCoreEventClass, kAEQuitApplication, NewAEEventHandlerProc (HandleQuit), 0, false);

	return err;
}

pascal OSErr HandleOApp (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefcon) {
#pragma unused (theAppleEvent, reply, handlerRefcon)

	return noErr;				/* We're up and running */
}





pascal OSErr HandleQuit (AppleEvent *theAppleEvent, AppleEvent *reply, long handlerRefcon) {
#pragma unused (theAppleEvent, reply, handlerRefcon)

	gQuitting = true;
	return noErr;
}



